checkRequire("Lua_IconShowItem");
Lua_ShopBasePanel = class("Lua_ShopBasePanel", Lua_DisplayObject);
function Lua_ShopBasePanel:ctor(p, skin)
	self:superCall("ctor", p, skin);
end

function Lua_ShopBasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.refreshBtn:addClickFuntion(self, self.onRefreshBtnClick);

	self:addLuaEvent("MONEY_UPDATE", self, self.onMoneyUpdate);
	self:addLuaEvent("SINGLE_ITEM_UPDATE", self, self.onPackUpdate);
end

function Lua_ShopBasePanel:dispose()
	if self.moneyArr ~= nil then
		self.moneyArr:dispose();
		self.moneyArr:clear();
		self.moneyArr = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ShopBasePanel:onMoneyUpdate(dic)
	if dic == nil or self.moneyArr == nil then
		return;
	end

	local moneyType;
	for i = 1, self.moneyArr:getSize() do
		moneyType = self.moneyArr[i].iconId;
		if moneyType ~= nil and dic[moneyType] ~= nil then
			self.moneyArr[i]:setCount(numberTrans(DataCenter.moneyData:getMoney(moneyType)), "FFFFFF");
		end
	end
end

function Lua_ShopBasePanel:onPackUpdate(vo)
	if vo == nil then
		return;
	end

	for i = 1, self.moneyArr:getSize() do
		if vo.id == self.moneyArr[i].iconId then
			self.moneyArr[i]:setCount(numberTrans(DataCenter.packData:getItemCountById(vo.id)), "FFFFFF");
			break;
		end
	end
end

function Lua_ShopBasePanel:setData(data)
	if data == nil or self.data == data then
		return;
	end
	self.data = data;
	
	if self.moneyArr == nil then
		self.moneyArr = Array();
	end
	local len = self.moneyArr:getSize();
	for i = 1, len do
		self.moneyArr[i]:setEnable(false);
	end
	if data.moneyType ~= nil then
		len = #data.moneyType;
		local moneyType;
		local item;
		local tvo;
		local haveCount;
		for i = 1, len do
			moneyType = data.moneyType[i];
			if self.moneyArr[i] == nil then
				item = Lua_IconShowItem.new(self.upObj);
				self.moneyArr:add(item);
			else
				item = self.moneyArr[i];
			end
			item:setEnable(true);
			item:setLocation(270 - (i - 1) * 175, 680, 0);
			item:setBg(true, nil, nil, 130);
			tvo = Lua_ToolVo.createToolVo(moneyType);
			haveCount = DataCenter.packData:getItemCountById(moneyType);
			item:setIcon(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth, tvo.iconHeight);
			item:setIconClick(moneyType);
			item:setAddClick();
			item:setCount(numberTrans(haveCount), "FFFFFF");
		end
	end
	Lua_ProxyManager.getProxy("Lua_ShopProxy"):sShopInfo(data.shopType);
end

function Lua_ShopBasePanel:onRefreshBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.showLangValue(10031);
		return;
	end
	self.clickTime = getTime();
end