checkRequire("Lua_ShopSubTypeItem");
checkRequire("Lua_ShopBtnItem");
Lua_ShopWindow = class("Lua_ShopWindow", Lua_Window);
function Lua_ShopWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/shop/ui_sd_bj_001.jpg";
	self.windowName = "Lua_ShopWindow";
	self.skinName = "ShopWindow_skin";

	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);	
	self:addPreLoadRes("/images/shop/ui_sd_bj_002.png", Lua_LoadFileType.IMG); -- 猫url
end

function Lua_ShopWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("SHOP_SUBTYPE_SELECT", self, self.onShopSubTypeSelect);
	self:addLuaEvent("SHOP_TYPE_SELECT", self, self.onShopTypeSelect);
	-- 到达商店刷新时间
	self:addLuaEvent("REFRESH_SHOP_INFO", self, self.updateShopTypePanel);	
end

function Lua_ShopWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.catImg:setEnable(false);
	self.catImg:setUrl(nil);
	
	self.subTypeList = Lua_DragList.new(self.upObject, 676, 76, Lua_AxisDefine.Horizontal);
	self.subTypeList:setListCell(Lua_ShopSubTypeItem, 169, 76, 1);
	self.subTypeList:setLocation(0, 393, 0);
	self.subTypeList.callBackOwner = self;
	self.subTypeList.dragCallBack = self.updateArrowShow;
	self.subTypeList.content.name = "subTypeList";

	self:onScreenResize();
end

function Lua_ShopWindow:dispose()
	if self.subTypeList ~= nil then
		self.subTypeList:dispose();
		self.subTypeList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.shopPanel ~= nil then
		self.shopPanel:dispose();
		self.shopPanel = nil;
	end

	DataCenter.shopData:dispose();
	self:superCall("dispose");
end

function Lua_ShopWindow:onScreenResize()
	self:superCall("onScreenResize");
	
	self.bg:SetDimensions(720, 1006 + self.adaptHeight);

	if self.shopPanel ~= nil then
		self.shopPanel:setRectSize(self.width, self.height);
	end
end

function Lua_ShopWindow:showWin(param)
	self:superCall("showWin", param);

	local index = 1;
	local arr = DataCenter.shopUtil.getShopSubTypeArr;
	if type(param) == "number" then
		index = self:getIndexBySubType(arr, param);
	elseif type(param) == "table" and param.main_id ~= nil then
		index = self:getIndexBySubType(arr, param.main_id);
	end

	self.subTypeList:setArrayData(arr);
	self.subTypeList:moveToIndex(index, true, false);
	self.subTypeList.showDragDataList[index].cell:onPressClick();
end

function Lua_ShopWindow:getIndexBySubType(arr, subType)
	for i = 1, arr:getSize() do
		if arr[i].id == subType then
			return i;
		end
	end
	return 1;
end

function Lua_ShopWindow:onShopSubTypeSelect(data)
	if data == nil or data.id == DataCenter.shopData.subType then
		return;
	end
	DataCenter.shopData.subType = data.id;

	-- 设置选中
	local arr = self.subTypeList.showList;
	for i = 1, arr:getSize() do
		arr[i]:updateSelect();
	end
	-- 设置移动到对应索引
	-- arr = self.subTypeList.showDragDataList;
	-- local index = 1;
	-- for i = 1, arr:getSize() do
	-- 	if arr[i].data.id == data.id then
	-- 		index = i;
	-- 		break;
	-- 	end
	-- end
	-- self.subTypeList:moveToIndex(index, false, false);

	self.winBgPath = data.winBg;
	self.winBg:setUrl(self.winBgPath);
	self.btnBg:setEnable(false);

	if data.childShop == nil or #data.childShop == 0 then
		self.bShowBtn = false;
		if self.btnList ~= nil then
			self.btnList:dispose();
			self.btnList = nil;
		end
		if self.shopPanel ~= nil then
			self.shopPanel:dispose();
			self.shopPanel = nil;
		end
	elseif #data.childShop == 1 then
		self.bShowBtn = false;
		if self.btnList ~= nil then
			self.btnList:setEnable(false);
		end
		local vo = DataCenter.shopUtil:getShopTypeVo(data.childShop[1]);
		self:onShopTypeSelect(vo);
	else
		self.bShowBtn = true;
		self.btnArr = Array();
		local vo;
		index = 1;
		for i = 1, #data.childShop do
			vo = DataCenter.shopUtil:getShopTypeVo(data.childShop[i]);
			if vo.shopType == DataCenter.shopData.shopType then
				index = i;
			end
			self.btnArr:add(vo);
		end
		if self.btnList == nil then
			-- self.btnList = Lua_DragList.new(self.content, 600, 45, Lua_AxisDefine.Vertical);
			-- self.btnList:setListCell(Lua_ShopBtnItem, 120, 45, 3);
			-- self.btnList:setRectAnchor(1);
			-- self.btnList:setLocation(0, -415, 0);
			-- self.btnList.content.name = "btnList";

			self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
            self.btnList:setLocation(0, -418.5, 0);
            self.btnList:setRectAnchor(1);
            self.btnList:setButtonCell(Lua_ShopBtnItem);
            self.btnList:setButtonItem(140, 51);
		end
		-- self.btnList:setEnable(true);
		-- self.btnList:setArrayData(self.btnArr, false);
		-- self.btnList:moveToIndex(index, true, false);
		-- self.btnList.showDragDataList[index].cell:onPressClick();

		self.btnList:setData(self.btnArr);
        self.btnList:setSelected(index);
        self.btnList.showList[index]:onPressClick();
        self.btnList:setEnable(true);

		self.btnBg:SetDimensions(self.btnArr:getSize() * 140 + 20, 51);
		self.btnBg:setEnable(true);
	end
end

function Lua_ShopWindow:onShopTypeSelect(data)
	if data == nil or self.shopType == data.shopType then
		return;
	end
	self.shopType = data.shopType;
	DataCenter.shopData.shopType = data.shopType;

	-- -- 设置选中
	-- if self.bShowBtn == true and self.btnList ~= nil then
	-- 	local showList = self.btnList.showList;
	-- 	for i = 1, showList:getSize() do
	-- 		showList[i]:updateSelect();
	-- 	end
	-- end

	if self.panelStr ~= data.panelStr then
		if self.shopPanel ~= nil then
			self.shopPanel:dispose();
			self.shopPanel = nil;
		end
	end
	if self.shopPanel == nil then
		local showPanel = checkRequire(data.panelStr);
		self.shopPanel = showPanel.new(self.content);
		self.shopPanel:setRectSize(self.width, self.height);
		self.shopPanel:onScreenResize(self.adaptHeight);
	end
	self.shopPanel:setData(data, self.bShowBtn);
end

function Lua_ShopWindow:updateArrowShow(curSubPos)
	self.leftArrowIcon:setEnable(curSubPos <= 85);
	self.rightArrowIcon:setEnable(curSubPos >= -85);
end

function Lua_ShopWindow:updateShopTypePanel()
	if self.shopType ~= nil then
		Lua_ProxyManager.getProxy("Lua_ShopProxy"):sShopInfo(self.shopType);
	end
end
