Lua_ShopSubTypeItem = class("Lua_ShopSubTypeItem", Lua_ListCell);
function Lua_ShopSubTypeItem:ctor(p)
	self:superCall("ctor", p, "ShopTypeItem_skin");
end

function Lua_ShopSubTypeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ShopSubTypeItem:dispose()
	self:superCall("dispose");
end

function Lua_ShopSubTypeItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	self.isOpened = data.bOpened;
	self.bCheckAlliance = data.bCheckAlliance;
	self.isJoinAlliance = DataCenter.roleData.league_id ~= 0;

	local isGray = false;
	if self.isOpened then
		if self.bCheckAlliance then
			isGray = not self.isJoinAlliance;
		end
	else
		isGray = true;
	end
	self.btnSp:setGray(isGray);
	self.shopNameTxt:setGray(isGray);

	self:updateSelect();
end

function Lua_ShopSubTypeItem:onPressClick()
	if self.data == nil then
		return;
	end

	if self.isOpened then
		if self.bCheckAlliance and not self.isJoinAlliance then
			OperateAlert.showLangValue(125023);
			return;
		end
	else
		self.data:showFuncAdvance();
		return;
	end

	Lua_MsgUtil.callFunc("SHOP_SUBTYPE_SELECT", self.data);
end

function Lua_ShopSubTypeItem:updateSelect()
	if self.data == nil then
		return;
	end

	if self.data.id == DataCenter.shopData.subType then
		self.shopNameTxt.text = "<color=#fefdf5>" .. self.data.name .. "</color>";
		self.btnSp:setAltas("shop_atlas_1", "ui_sd_tab_01_s");
		self.btnSp:resetSize();
    else
    	self.shopNameTxt.text = "<color=#ececec>" .. self.data.name .. "</color>";
    	self.btnSp:setAltas("shop_atlas_1", "ui_sd_tab_01");
    	self.btnSp:resetSize();
    end
end