Lua_SpiritShopItem = class("Lua_SpiritShopItem", Lua_ListCell);
function Lua_SpiritShopItem:ctor(p)
	self:superCall("ctor", p, "SpiritShopItem_skin");
end

function Lua_SpiritShopItem:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ItemIcon.new(self.content);
	self.item:setLocation(0, 0, 0);
	self.item:setCanClick(true);
	self.item:setSiblingIndex(1);
end

function Lua_SpiritShopItem:setData(data)
	if data == nil then
		return;
	end

	self.data = data;
	self.item:setData(data.itemVo);
	self.itemName.text = data.itemVo.name;

	if data.recommend > 0 then
		self.discountIcon:setEnable(true);
		-- self.discountIcon:setAltas("shop_atlas_1", "推荐图片");
	elseif data.discount > 0 then
		self.discountIcon:setEnable(true);
		self.discountIcon:setAltas("shop_atlas_1", "ui_sd_label_0"..data.discount);
	else
		self.discountIcon:setEnable(false);
	end

	if self.data.isSoldOut then
		self.sellOutObj:SetActive(true);
	else
		self.sellOutObj:SetActive(false);
	end

	if data.moneyCount ~= 0 then
		local toolVo = Lua_ToolVo.createToolVo(data.moneyType);
		if toolVo ~= nil then
			self.costIcon:setAltas(toolVo.iconAtlas, toolVo.iconSprite);
		end

		if DataCenter.packData:getItemCountById(data.moneyType) < data.moneyCount then
			self.costCount.text = "<color=#FF0000>" .. numberTrans(data.moneyCount) .. "</color>" ;
		else
			self.costCount.text = numberTrans(data.moneyCount);
		end
	else
		self.costCount:setLangValue(125011);
	end

	self:showHighlightEff(data.highlightEff);
end

function Lua_SpiritShopItem:showHighlightEff(effectName)
	if effectName ~= nil then
		if self.highlightEff == nil then
			self.highlightEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..effectName, effectName, 0, -2);
			self.highlightEff:SetRenderQueue(5, 1, UIEffect.NormalSort);
		end
		self.highlightEff:setEnable(true);
	else
		if self.highlightEff ~= nil then
			self.highlightEff:setEnable(false);
		end
	end
end

function Lua_SpiritShopItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 50, 100, 100);
	if showRect:containeRect(rect) == true then
		self.item:showEffect(true);
		if self.data.highlightEff ~= nil and self.highlightEff ~= nil then
			self.highlightEff:setEnable(true);
		end
	else
		self.item:showEffect(false);
		if self.highlightEff ~= nil then
			self.highlightEff:setEnable(false);
		end
	end
end

function Lua_SpiritShopItem:onPressClick()
	if self.data ~= nil then
		if self.data.isSoldOut then
			OperateAlert.showLangValue(125014);
		elseif self.data.vip_level > DataCenter.roleData.vip then
			OperateAlert.showLangValue(125021);
		else
			if DataCenter.moneyData:isMoneyEnough(self.data.moneyType, self.data.moneyCount, true, true) then
				self.data.parentShopType = Lua_ShopData.SPIRIT_SHOP; -- 特卖店购买窗口部分按钮置灰的标签
				Lua_WindowUtil.openWin("Lua_BuyGoodsWindow", Lua_WinParam.ACTION_OPEN, self.data);
				-- Lua_ProxyManager.getProxy("Lua_ShopProxy"):sBuyShopItem(self.data.id, self.data.shopType, 1, self.data.index);
			end
		end
	end
end

function Lua_SpiritShopItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
end

function Lua_SpiritShopItem:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end
	if self.data ~= nil then
		self.data.highlightEff = nil;
		self.data = nil;
	end
	if self.highlightEff ~= nil then
		self.highlightEff:dispose();
		self.highlightEff = nil;
	end
	self:superCall("dispose");
end